<?php

namespace App\Filament\Resources\ClientResource\RelationManagers;

use App\Filament\Exports\ClientAccountsExporter;
use App\Models\Account;
use Filament\Actions\Exports\Enums\ExportFormat;
use Filament\Forms;
use Filament\Forms\Form;
use Filament\Resources\RelationManagers\RelationManager;
use Filament\Tables;
use Filament\Tables\Table;

class AccountsRelationManager extends RelationManager
{
    protected static string $relationship = 'accounts';

    public function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\TextInput::make('account')->required(),
                Forms\Components\Textarea::make('description')->nullable(),
                Forms\Components\Select::make('account_type_id')
                    ->relationship('accountType', 'type')
                    ->required(),
                Forms\Components\Select::make('normal_balance')->options(
                    ['debit' => 'Debit', 'credit' => 'Credit']
                )->required(),
            ]);
    }

    public function table(Table $table): Table
    {
        return $table
            ->recordTitleAttribute('client_id')
            ->columns([
                Tables\Columns\TextColumn::make('account')->description(fn (Account $record): string => $record->description ?? ''),
                Tables\Columns\TextColumn::make('accountType.type'),
                Tables\Columns\TextColumn::make('accountType.normal_balance')->label('Normal Balance'),
            ])
            ->filters([
                //
            ])
            ->headerActions([
                Tables\Actions\ExportAction::make('Export Accounts')->exporter(ClientAccountsExporter::class)->formats([ExportFormat::Csv]),
                Tables\Actions\CreateAction::make()->label('New Account')->icon('heroicon-o-plus')->slideOver(),
            ])
            ->actions([
                Tables\Actions\EditAction::make()->slideOver(),
                Tables\Actions\DeleteAction::make()->requiresConfirmation(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make()->icon('heroicon-s-trash')->requiresConfirmation(),
                ]),
            ]);
    }
}
